#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

vector<ll> p2(32);

map<pair<ll, ll>, ll> col;
set<pair<ll, ll> > old;
vector<ll> a;
ll k, n, m, ci, vi, curr = 0;
map<pair<ll, ll>, vector<ll> > cnt;

void print(vector<auto> &tp)
{
    for (auto i : tp)
        cout << i << " ";
    //cout << endl;
}

void set_old(ll l, ll r, ll ql, ll qr, ll c)
{
    //cerr << l << " " << r << " " << ql << " " << qr << " " << c << endl;
    if (cnt.find({l, r}) == cnt.end())
        cnt[{l, r}] = a;
    if (r <= ql || l >= qr)
        return;
    if (ql <= l && qr >= r)
    {
        old.insert({l, r});
        col[{l, r}] = c;
        cnt[{l, r}][c] = 1LL;
        //cout << l << " " << r - 1 << ": ";
        //print(cnt[{l, r}]);
        //cout << endl;
        return;
    }
    set_old(l, (l + r) / 2, ql, qr, c);
    set_old((l + r) / 2, r, ql, qr, c);
    for (int i = 1; i <= m; ++i)
    {
        cnt[{l, r}][i] = cnt[{l, (l + r) / 2}][i] + cnt[{(l + r) / 2, r}][i];
    }
    return;
}

void relax(ll l, ll r)
{
    if (old.find({l, r}) != old.end())
        return;
    relax(l, (l + r) / 2);
    relax((l + r) / 2, r);

    ll max_rel = 0LL, cur, ans = -1;
    for (int i = 1; i <= m; ++i)
    {
        cur = cnt[{l, (l + r) / 2}][i] + cnt[{(l + r) / 2, r}][i];
        if (cur > max_rel && cur > 1)
        {
            ans = i;
            max_rel = curr;
        }
    }
    if (ans != -1)
    {
        cnt[{l, r}][ans] = 1LL;
        col[{l, r}] = ans;
        //cout << "relaxed" << l << " " << r;
    }
}
vector<ll> st;
ll get_ans(ll l, ll r)
{
    ll ans = 0;
    if (old.find({l, r}) != old.end())
    {
        if (!st.empty() && st.back() == col[{l, r}])
            return 0LL;
        else
            return 1LL;
    }
    bool colored = false;
    if (col.find({l, r}) != col.end())
        colored = true;
    if (colored) st.push_back(col[{l, r}]);
    ans = get_ans(l, (l + r) / 2) + get_ans((l + r) / 2, r);
    if (colored) st.pop_back();

    if ((!colored) ||
         (!st.empty() && st.back() == col[{l, r}]))
        ans = ans;
    else
        ans = ans + 1;

    /*if (col.find({l, r}) != col.end())
        cout << "col[" << l << " " << r - 1 << "] = " << col[{l, r}] << endl;
    else
        cout << "col[" << l << " " << r - 1 << "] = " << -1 << endl;
    cout << "from " << l << " " << r - 1 << ": " << ans << endl;
    print(st);
    cout << endl;*/
    return ans;
}

int main()
{
    //freopen("file.in", "r", stdin);
    //freopen("file.out", "w", stdout);
    //cout << log2(1e12);
    p2[0] = 1LL;
    for (int i = 1; i < 32; ++i)
        p2[i] = p2[i - 1] * 2LL;

    cin >> k >> n >> m;
    a.assign(m + 1, 0);

    for (int i = 0; i < n; ++i)
    {
        cin >> ci >> vi;
        set_old(0, p2[k], curr, curr + ci, vi);
        curr += ci;
    }
    relax(0, p2[k]);
    /*for (ll i = 0; i < 100; ++i)
    {
        for (ll j = 0; j < 100; ++j)
        {
            pair<ll, ll> q = {i, j};
            if (col.find(q) != col.end())
            {
                cout << "[" << q.first << " " << q.second - 1 << "] - " << col[q] << "\n";
                //print(cnt[{q}]);
                //cout << "]\n";
                if (old.find(q) != old.end())
                    cout << "YES\n";
                else
                    cout << "NO\n";
            }
        }
    }*/
    cout << get_ans(0, p2[k]) << endl;
    return 0;
}
