#include <bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<ll> > g;
vector<ll> p;
vector<ll> h1;
vector<ll> h2;

void dfs(int v)
{
    if (g[v].size() == 0)
    {
        h1[v] = 1;
        h2[v] = 1;
        return;
    }
    ll max1 = -1, max2 = -1;
    for (int u : g[v])
    {
        dfs(u);
        if (h1[u] > max1)
        {
            max2 = max1;
            max1 = h1[u];
        }
        else if(h1[u] > max2)
        {
            max2 = h1[u];
        }
    }
    if (max1 != -1)
        h1[v] = max1 + 1;
    if (max2 != -1)
        h2[v] = max2 + 1;
}

int main()
{
    //freopen("file.in", "r", stdin);
    int n, m;
    cin >> n >> m;
    p.resize(n);
    g.resize(n);
    h1.assign(n, -1);
    h2.assign(n, -1);
    p[0] = -1;
    for (int i = 1; i < n; ++i)
    {
        cin >> p[i]; p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0);
    ll maxh1 = -1;
    for (int i = 0; i < n; ++i)
        maxh1 = max(maxh1, h1[i]);
    ll ans = -1LL, curr = -1LL;
    for (int i = 0; i < n; ++i)
    {
        curr = h1[i] + (maxh1 * (m - 1));
        if (h2[i] != -1)
            curr += (h2[i] - 1) + (maxh1 * (m - 1));
        ans = max(ans, curr);
    }
    cout << ans << endl;
    return 0;
}
